-------------------------------------------------------------------------------
-- NineResourcez
-------------------------------------------------------------------------------
NineResourcez = NineResourcez or {}

NineResourcez.name = "NineResourcez"
NineResourcez.addonMenuName = "Nine Resourcez"
NineResourcez.version = "1.3.5"
NineResourcez.displayName = "|c90C7C7Nine Resourcez|r"
NineResourcez.author = "|c00a313Teebow Ganx|r"
NineResourcez.website = "https://www.youtube.com/channel/UCqE9Vi36WzTJBBbo9-G40bg"
NineResourcez.donation = "https://www.youtube.com/channel/UCqE9Vi36WzTJBBbo9-G40bg"

NineResourcez.registered = false

NineResourcez.slashCommand = "/9rss"
NineResourcez.settingsSlashCommand = "/9rsz"

NineResourcez.SavedVariablesName = "NineResourcez_SavedVariables"
NineResourcez.savedVarsVersion = 2

NineResourcez.pinType = "Nine_Resourcez_Pin_Type"

NineResourcez.rsrcsQuestID = 6208
NineResourcez.rsrcsQuestName = nil
NineResourcez.rsrcsQuestCount = 9

NineResourcez.keepsQuestID = 3431
NineResourcez.keepsQuestName = nil
NineResourcez.keepsQuestCount = 3

-- local theTimeStamp = os.time(os.date('*t')) -- timestamp for current local time
-- local prettyLocalTime = os.date('%A, %B %d %Y at %I:%M:%S%p', os.time(os.date('*t'))) --  Might return Friday, June 09 2018 at 12:42:19AM
-- local prettyDateTime = os.date('%A, %B %d %Y at %I:%M:%S%p', theTimeStamp)

--Locals -------------------------------------------------------------

local LCLSTR = NineResourcez.Localization

local pinTextures = {
    [1] = "esoui/art/hud/radialicon_cancel_over.dds",
    [2] = "esoui/art/icons/guildranks/guild_indexicon_recruit_down.dds",
    [3] = "esoui/art/tutorial/gamepad/gp_overview_menuicon_scoring.dds",
    [4] = "esoui/art/tutorial/gamepad/gp_overview_menuicon_bonus.dds",
    [5] = "esoui/art/miscellaneous/gamepad/gp_bullet_ochre.dds",
}

-- Saved Variables --------------------------------------------------------------

local savedVariables

local defaults = {
	debug = false,
	currQuestID = nil,
	pinTexture = {
			path = pinTextures[3],
			size = 24,
			level = 59,
	},
	pinColor =                 {
		[1] = 0.3019607961, -- r
		[2] = 0.7568627596, -- g
		[3] = 0.2431372553, -- b
		[4] = 1, -- a
	},
	pinDB = {}
}

local color = {

	red 		= "FF0000",	-- bright red
	darkRed 	= "980000", -- red berry
	orange 		= "FF9900",	-- orange
	lightOrange = "FFB74C", -- light orange
	gold 		= "F1C232", -- dark yellow 1
	yellow 		= "FFFF00", -- yellow
	green 		= "00ff00",	-- green
	teal 		= "90C7C7",	-- teal
	lightBlue 	= "4A86E8",	-- cornflower blue
	blue 		= "0000FF",	-- blue
	purple 		= "9900FF",	-- purple
	magenta 	= "FF00FF",	-- magenta
	white 		= "FFFFFF",	-- white
	gray 		= "CCCCCC",	-- gray
	darkGray 	= "666666",	-- dark gray 3
	black 		= "000000",	-- black

	default = white,
}

local captureAreaID = 0
local captureAreaKeepID = 0
local captureAreaName = ""
local captureAreaX = 0
local captureAreaY = 0
local captureAreaType = 0

local function DebugStr(inStr)
	local debug = savedVariables.debug or false
	if debug == true then 
		local debugStr = string.format("9RDebug: %s", inStr)
		d(debugStr) 
	end
end

local function Colorize(str, clr)
    str = str or ""
    clr = clr or color.default
	return string.format("|c%s%s|r", clr, str)
end

local function IsQuestInJournal(inQuestName) -- returns true or false

	local questCount = GetNumJournalQuests()
	local qInfo = nil
	for i = 1,questCount do
		local questName,
			  backgroundText,
			  activeStepText,
			  activeStepType,
			  activeStepTrackerOverrideText,
			  completed,
			  tracked,
			  questLevel,
			  pushed,
			  questType,
			  instanceDisplayType_= GetJournalQuestInfo(i)

		if questName == inQuestName then return true end
	end

	return false
end

local function AddPinToMap(pinInfo)
	if pinInfo == nil then DebugStr("pinInfo == nil in AddPinToMap") return false end
	if pinInfo.pinX == nil or (pinInfo.pinX<=0 or pinInfo.pinX>=1) then DebugStr("pinInfo.pinX is invalid in AddPinToMap") return false end
	if pinInfo.pinY == nil or (pinInfo.pinY<=0 or pinInfo.pinY>=1) then DebugStr("pinInfo.pinX is invalid in AddPinToMap") return false end
	LibMapPins:CreatePin(NineResourcez.pinType, pinInfo, pinInfo.pinX, pinInfo.pinY)
	return true
end

local function FindPin(theID)
	for i, pinInfo in ipairs(savedVariables.pinDB) do
		if pinInfo.ID == theID then return pinInfo, i end
	end
	return nil, nil
end

local function NewPin(inID, inName, inX, inY, inType)

	-- If the pin already exists, just return nil, unable to create this pin
	if FindPin(inID) then DebugStr("FindPin(inID) == true in NewPin()") return nil end
	if inID == nil then DebugStr("inID == nil in NewPin()") return nil end
	if inName == nil then DebugStr("inName == nil in NewPin()") return nil end
	if inX == nil or (inX<=0 or inX>=1) then DebugStr("inX is invalid in NewPin()") return nil end
	if inY == nil or (inY<=0 or inY>=1) then DebugStr("inX is invalid in NewPin()") return nil end

	-- Create a new pin & add it to the map
	local newPin = {
		ID = inID,
		name = inName,
		pinX = inX,
		pinY = inY,
		rsrcType = inType,
		timeStamp = os.time(os.date('*t')) -- Add timestamp to when pin was created
	}

	if AddPinToMap(newPin) == true then
		table.insert(savedVariables.pinDB, newPin)
		LibMapPins:RefreshPins(NineResourcez.pinType)
		return newPin
	else
		DebugStr("AddPinToMap() == false in NewPin()")
	end

	return nil
end

local function DistanceToPlayer(inX, inY)
	local playerX, playerY = GetMapPlayerPosition('player')
	local distance = math.sqrt(((inX-playerX)*(inX-playerX))+((inY-playerY)*(inY-playerY))) * 100
	return distance
end

local function FindNearestKeep()

	local keepDistance = nil
	local keepID = nil
	local keepX, keepY = nil
	local selfX, selfY = GetMapPlayerPosition('player')
	local locName = GetPlayerLocationName() -- Player could be at keep

	for i = 1, GetNumKeeps() do
		local theKeep, bgContext = GetKeepKeysByIndex(i)
		if GetKeepResourceType(theKeep) == RESOURCETYPE_NONE then
			local keepName = GetKeepName(theKeep)
			local _, targetX, targetY = GetKeepPinInfo(theKeep, bgContext)
			if keepName == locName then
				DebugStr(string.format("FindNearestKeep: '%s' found by player location name.", locName))
				return theKeep, targetX, targetY
			end
			if targetX ~= 0 and targetY ~= 0 then
				local distance = DistanceToPlayer(targetX, targetY)
				if (keepDistance == nil) or (distance < keepDistance) then
					keepDistance = distance
					keepID = theKeep
					keepX = targetX
					keepY = targetY
					DebugStr(string.format("FindNearestKeep: %s has a distance of %10f.", keepName, keepDistance))
				end
			end
		end
	end
	DebugStr(string.format("FindNearestKeep: %s, keepID = %d, keepX = %10f, keepY = %10f", GetKeepName(keepID) or "None Found!", keepID or 0, keepX or 0, keepY or 0))
	return keepID, keepX, keepY
end

local function GetResourceInfo(keepID, rsrcType, selfX, selfY)

	local targetID = GetResourceKeepForKeep(keepID, rsrcType)
	local rsrcPinType, targetX, targetY = GetKeepPinInfo(targetID, 1)
	local distance = DistanceToPlayer(targetX, targetY)
	local rsrcName = GetKeepName(targetID) or "NONE FOUND!"

	return targetID, rsrcName, targetX, targetY, distance
end

local function FindNearestResource() -- returns rsrcID, rsrcName, rsrcX, rsrcY, rsrcType
	local keepID, keepX, keepY = FindNearestKeep()
	if keepID == nil then
		DebugStr("NineResourcez: FindNearestKeep() failed!")
		return nil, nil, nil, nil, nil
	else
		DebugStr(string.format("NineResourcez: Nearest keep is %s", GetKeepName(keepID)))
	end

	local rsrcDistance = nil
	local rsrcID = 0
	local rsrcX, rsrcY = 0
	local rsrcType = nil
	local rsrcName = "Unnamed"
	local locName = GetPlayerLocationName()

	local targetType = RESOURCETYPE_FOOD
	local targetID, targetName, targetX, targetY, distance = GetResourceInfo(keepID, targetType)

	if targetName == locName then
		DebugStr(string.format("FindNearestResource: '%s' found by player location name.", locName))
		return targetID, locName, targetX, targetY, targetType	
	end

	DebugStr(string.format("NineResourcez: Nearest farm is %s, distance = %10f", targetName, distance or -1))

	rsrcDistance = distance
	rsrcID = targetID
	rsrcX = targetX
	rsrcY = targetY
	rsrcType = targetType
	rsrcName = targetName

	targetType = RESOURCETYPE_WOOD
	targetID, targetName, targetX, targetY, distance = GetResourceInfo(keepID, targetType)

	if targetName == locName then
		DebugStr(string.format("FindNearestResource: '%s' found by player location name.", locName))
		return targetID, locName, targetX, targetY, targetType	
	end

	DebugStr(string.format("NineResourcez: Nearest mill is %s, distance = %10f", targetName, distance or -1))

	if distance < rsrcDistance then
		rsrcDistance = distance
		rsrcID = targetID
		rsrcX = targetX
		rsrcY = targetY
		rsrcType = targetType
		rsrcName = targetName
	end

	targetType = RESOURCETYPE_ORE
	targetID, targetName, targetX, targetY, distance, rsrcType = GetResourceInfo(keepID, targetType)

	if targetName == locName then
		DebugStr(string.format("FindNearestResource: '%s' found by player location name.", locName))
		return targetID, locName, targetX, targetY, targetType
	end

	DebugStr(string.format("NineResourcez: Nearest mine is %s, distance = %10f", targetName, distance or -1))

	if distance < rsrcDistance then
		rsrcDistance = distance
		rsrcID = targetID
		rsrcX = targetX
		rsrcY = targetY
		rsrcType = targetType
		rsrcName = targetName
	end

	DebugStr(string.format("Nine Resourcez: Nearest resource is %s. ID = %d, X = %10f, Y = %10f", rsrcName, rsrcID, rsrcX, rsrcY))

	return rsrcID, rsrcName, rsrcX, rsrcY, rsrcType
end

local function CurrCaptureQuest() -- returns curr quest name & capture count
	if savedVariables.currQuestID == NineResourcez.rsrcsQuestID then return NineResourcez.rsrcsQuestName, NineResourcez.rsrcsQuestCount end
	if savedVariables.currQuestID == NineResourcez.keepsQuestID then return NineResourcez.keepsQuestName, NineResourcez.keepsQuestCount end
	return nil, nil
end

local function ListCaptures()
	if savedVariables.suppressMsgs == true then return end
	local questName, capMax  = CurrCaptureQuest()
	if questName == nil then return end
	questName = Colorize(questName, color.teal)
	d(string.format("%s [%d/%d]:", questName, #savedVariables.pinDB, capMax))
	for i, pinInfo in ipairs(savedVariables.pinDB) do
		d(string.format("   %d) %s", i, pinInfo.name))
	end
end


-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Event Handlers to track 9 resources quest
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 

-- EVENT_QUEST_ADDED (*luaindex* _journalIndex_, *string* _questName_, *string* _objectiveName_)
function NineResourcez.EVENT_QUEST_ADDED(eventCode, journalIndex, questName, objectiveName)
		
	local questID = nil
	local level = 59

	if questName == NineResourcez.rsrcsQuestName then 
		questID = NineResourcez.rsrcsQuestID
	elseif questName == NineResourcez.keepsQuestName then 
		questID = NineResourcez.keepsQuestID
		level = 99 -- Pins must be on top of keeps, not below
	end

	if questID == nil then return end

	savedVariables.currQuestID = questID
	savedVariables.pinDB = {}

	LibMapPins:SetLayoutKey(NineResourcez.pinType, "level", level)
	LibMapPins:RefreshPins(NineResourcez.pinType)
	questName = Colorize(questName, color.teal)
	if savedVariables.suppressMsgs == true then return end
	d(string.format(LCLSTR["NOW_TRACKING"], questName))
end

-- * EVENT_QUEST_CONDITION_COUNTER_CHANGED (*luaindex* _journalIndex_, *string* _questName_, *string* _conditionText_, *[QuestConditionType|#QuestConditionType]* _conditionType_, *integer* _currConditionVal_, *integer* _newConditionVal_, *integer* _conditionMax_, *bool* _isFailCondition_, *string* _stepOverrideText_, *bool* _isPushed_, *bool* _isComplete_, *bool* _isConditionComplete_, *bool* _isStepHidden_, *bool* _isConditionCompleteStatusChanged_, *bool* _isConditionCompletableBySiblingStatusChanged_)
function NineResourcez.EVENT_QUEST_CONDITION_COUNTER_CHANGED(eventCode, journalIndex, questName, conditionText, conditionType, currConditionVal, 
																newConditionVal, conditionMax, isFailCondition, stepOverrideText, isPushed, 
																isComplete, isConditionComplete, isStepHidden, isConditionCompleteStatusChanged, 
																isConditionCompletableBySiblingStatusChanged)
	
	if savedVariables.currQuestID == nil then return end -- Not tracking any capture quest? bye.

	local currQuestName, capMax = CurrCaptureQuest()
	if questName ~= currQuestName then return end -- Only care about the 9 resources or 3 keeps quest, so bye.

	local nearestKeepID, nearestName, nearestX, nearestY, nearestType = nil
	
	if savedVariables.currQuestID == NineResourcez.rsrcsQuestID then
		nearestKeepID, nearestName, nearestX, nearestY, nearestType =FindNearestResource()
	else
		nearestKeepID, nearestX, nearestY, nearestType =FindNearestKeep()
		if nearestKeepID ~= nil then nearestName = GetKeepName(nearestKeepID) end
	end

	if nearestKeepID == nil or nearestKeepID == 0 or nearestX == 0 or nearestY == 0 then 
		DebugStr("Quest Counter Change: ERROR No nearby keep or resource found.") 
		return
	end

	local debugString = "Quest Counter Change: nearestKeepID (%d) not in captureArea"
	if nearestKeepID == captureAreaKeepID then debugString = "Quest Counter Change: nearestKeepID (%d) == captureAreaKeepID"
	elseif nearestKeepID == captureAreaID then debugString = "Quest Counter Change: nearestKeepID (%d) == captureAreaID"
	end
	DebugStr(string.format(debugString, nearestKeepID))

	local battlegroundContext = 1 -- Always seems to be 1
	if GetKeepAlliance(nearestKeepID, battlegroundContext) ~= GetUnitAlliance("player") then
		DebugStr(Colorize(currQuestName, color.teal)..": ERROR - Nearby Keep & Player Alliances do not match!")
	end

	local newPin = NewPin(nearestKeepID, nearestName, nearestX, nearestY, nearestType)
	if newPin ~= nil then
		if savedVariables.suppressMsgs ~= true then
			local capStr = Colorize(LCLSTR["YOU_CAPTURED"], color.teal).." "..newPin.name.." "..Colorize(string.format("[%d/%d]", #savedVariables.pinDB, capMax), color.teal)
			d(capStr)
		end
	end	

	DebugStr(string.format("Quest Counter Change: %s %s [type=%d], curr=%d new=%d max=%d", 
							questName or "", conditionText, conditionType, currConditionVal, 
							newConditionVal, conditionMax))
end

-- EVENT_QUEST_COMPLETE (*string* _questName_, *integer* _level_, *integer* _previousExperience_, *integer* _currentExperience_, *integer* _championPoints_, *[QuestType|#QuestType]* _questType_, *[InstanceDisplayType|#InstanceDisplayType]* _instanceDisplayType_)
function NineResourcez.EVENT_QUEST_COMPLETE(eventCode, questName, level, previousExperience, currentExperience, championPoints, questType, instanceDisplayType)
	
	if questName ~= NineResourcez.rsrcsQuestName and questName ~= NineResourcez.keepsQuestName then return end
	if savedVariables.suppressMsgs == true then return end
	d(string.format(LCLSTR["QUEST_COMPLETED"], Colorize(questName, color.teal)))
	ListCaptures()
end

-- EVENT_QUEST_REMOVED (*bool* _isCompleted_, *luaindex* _journalIndex_, *string* _questName_, *luaindex* _zoneIndex_, *luaindex* _poiIndex_, *integer* _questID_)
function NineResourcez.EVENT_QUEST_REMOVED(eventCode, isCompleted, journalIndex, questName, zoneIndex, poiIndex, questID)

	if questName ~= NineResourcez.rsrcsQuestName and questName ~= NineResourcez.keepsQuestName then return end
	
	-- Remove all pin locations from the pin DB & refresh
	savedVariables.pinDB = {} 
	savedVariables.currQuestID = nil
	LibMapPins:RefreshPins(NineResourcez.pinType)

	if isCompleted == false and savedVariables.suppressMsgs ~= true then
		questName = Colorize(questName, color.teal)
		d(string.format(LCLSTR["QUEST_ABANDONED"], questName))
	end
end

-- * EVENT_CAPTURE_AREA_STATUS (*integer* _keepID_, *integer* _objectiveID_, *integer* _battlegroundContext_, *integer* _capturePoolValue_, *integer* _capturePoolMax_, *integer* _capturingPlayers_, *integer* _contestingPlayers_, *[Alliance|#Alliance]* _owningAlliance_, *[MapDisplayPinType|#MapDisplayPinType]* _pinType_)
function NineResourcez.EVENT_CAPTURE_AREA_STATUS(eventCode, keepID, objectiveID, battlegroundContext, capturePoolValue, capturePoolMax, capturingPlayers, contestingPlayers, owningAlliance, pinType)
	
	-- Only seem to get these events when player is on a flag which can be flipped.
	-- It gets called each time the circular flag meter changes.
	-- So we use these to know

	if savedVariables.currQuestID == nil then return end -- Don't have 9 resources or 3 keeps quest? Bye
	if keepID == captureAreaKeepID and (captureAreaID == objectiveID or captureAreaID == keepID) then return end -- We already set the data for this capture area. Bye
	if IsInCyrodiil() == false then return end -- Not in Cyrodiil? Bye
	if owningAlliance ~= GetUnitAlliance("player") then return end -- Only care if the player's alliance is capturing the flag
	
	local rsrcType = GetKeepResourceType(keepID)
	if rsrcType == RESOURCETYPE_NONE then 
		local theName, theType, theState = GetObjectiveInfo(objectiveID, keepID, battlegroundContext)
		DebugStr(string.format("Area Status says - capturing %s at %s", theName or "Unnamed Objective",  GetKeepName(keepID) or "Unnamed Keep"))
		return
	end

	local rsrcTypeName = "Farm"
	if rsrcType == RESOURCETYPE_WOOD then
		rsrcTypeName = "Lumbermill"
	elseif rsrcType == RESOURCETYPE_ORE then
		rsrcTypeName = "Mine"
	end

	-- Create data for this nearby resource in case it is captured and advances the quest.

	local theID = objectiveID
	local theName, theType, theState = GetObjectiveInfo(objectiveID, keepID, battlegroundContext)
	local thePinType, thePinX, thePinY, theContinuous = GetObjectivePinInfo(keepID, objectiveID, battlegroundContext)
	local theKeepPinType, theKeepX, theKeepY = GetKeepPinInfo(keepID, battlegroundContext)
	local theKeepName = GetKeepName(keepID)

	if theName == "" or theName == nil then 
		-- d(string.format("Objective (ID=%d) has no name, using parent keep name.", theID))
		theName = theKeepName or "Unnamed"
	end

	if thePinX == 0 or thePinY == 0 then
		thePinX = theKeepX
		thePinY = theKeepY
		theID = keepID
		DebugStr(string.format("CAPTURE_AREA_STATUS: Objective '%s' (ID=%d) has invalid coordinates, using keep coordinates (%10f, %10f)", 
								theName,  theID, thePinX, thePinY))
	end

	-- The information we need for a map pin is objective X & Y, keep ID, that's it.
	-- Update nearby flag information for when the resource keep flips

	captureAreaID = theID
	captureAreaKeepID = keepID
	captureAreaName = theName
	captureAreaX = thePinX
	captureAreaY = thePinY
	captureAreaType = rsrcType

	local captureStr = string.format("Player near flag during %s capture of %s [%d/%d], distance=%10f", 
										GetAllianceName(owningAlliance), GetKeepName(keepID), 
										capturePoolValue, capturePoolMax, DistanceToPlayer(thePinX, thePinY))
	DebugStr(captureStr)

end

-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
-- Slash Command
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 

SLASH_COMMANDS[NineResourcez.slashCommand] = function(extra)
	if savedVariables.currQuestID == nil then
		d(string.format(LCLSTR["NEITHER_QUEST"], NineResourcez.rsrcsQuestName, NineResourcez.keepsQuestName))
	else
		ListCaptures()
	end
end
-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

local function CreateSettingsMenu()

	local LAM = LibAddonMenu2

	local panelData = {
		type = "panel",
		name = NineResourcez.addonMenuName,
		displayName = NineResourcez.displayName,
		author = NineResourcez.author,
		version = NineResourcez.version,
		website = NineResourcez.website,
		donation = NineResourcez.donation,
		registerForRefresh = true,
		registerForDefaults = true,
		slashCommand = NineResourcez.settingsSlashCommand,
	}
	local settingsPanel = LAM:RegisterAddonPanel("NineResourcez_Pinz", panelData)
	
	local optionsData = {}
	local function AddControl(type, data)
		data.type = type
		optionsData[#optionsData + 1] = data
	end

	local function AddHeader(data) AddControl("header", data) end
	local function AddIconPicker(data) AddControl("iconpicker", data) end
	local function AddSlider(data) AddControl("slider", data) end
	local function AddColorPicker(data) AddControl("colorpicker", data) end
	local function AddCheckbox(data) AddControl("checkbox", data) end
	local function AddDropdown(data) AddControl("dropdown", data) end
	local function AddDivider(data) AddControl("divider", data) end

	local function AddCheckbox(data) AddControl("checkbox", data) end

	AddHeader({
		name = LCLSTR["SETTINGS_GENERAL_OPTIONS_HEADER"]
	})

	AddColorPicker({
		name = LCLSTR["SETTINGS_MAP_PIN_COLOR_LABEL"],
		tooltip = LCLSTR["SETTINGS_MAP_PIN_COLOR_DESCRIPTION"],
		getFunc = function() return unpack(savedVariables.pinColor) end,
		setFunc = function(r,g,b,a)
			savedVariables.pinColor = {r,g,b,a}
			LibMapPins:GetLayoutKey(NineResourcez.pinType, "tint"):SetRGBA(r,g,b,a)
			LibMapPins:RefreshPins(NineResourcez.pinType)
		end,
		default = ZO_ColorDef:New(unpack(defaults.pinColor))
	})

	AddSlider({
		name = LCLSTR["SETTINGS_MAP_PIN_SIZE_LABEL"],
		tooltip = LCLSTR["SETTINGS_MAP_PIN_SIZE_DESCRIPTION"],
		min = 16,
		max = 48,
		getFunc = function() return savedVariables.pinTexture.size end,
		setFunc = function(size)
			savedVariables.pinTexture.size = size
			LibMapPins:SetLayoutKey(NineResourcez.pinType, "size", size)
			LibMapPins:RefreshPins(NineResourcez.pinType)
		end,
		default = defaults.pinTexture.size
	})

	AddDivider({
	})

	AddCheckbox({
		name = LCLSTR["SETTINGS_SUPPRESS_MSGS_LABEL"],
		tooltip = LCLSTR["SETTINGS_SUPPRESS_MSGS_LABEL_DESCRIPTION"],
		getFunc = function() return savedVariables.suppressMsgs end,
		setFunc = function(newValue) savedVariables.suppressMsgs = newValue end,
		default = false
	})

	local allowDebugging = true
	if allowDebugging == true then 
		AddCheckbox({
			name = "Enable Debugging",
			tooltip = "Enable Debugging Features Of The Addon",
			getFunc = function() return savedVariables.debug end,
			setFunc = function(newValue) savedVariables.debug = newValue end,
			default = defaults.debug
		})
	end

	if savedVariables.debug == true then 

		AddSlider({
			name = LCLSTR["SETTINGS_MAP_PIN_LEVEL_LABEL"],
			tooltip = LCLSTR["SETTINGS_MAP_PIN_LEVEL_DESCRIPTION"],
			min = 1,
			max = 100,
			getFunc = function() return savedVariables.pinTexture.level end,
			setFunc = function(level)
				savedVariables.pinTexture.level = level
				LibMapPins:SetLayoutKey(NineResourcez.pinType, "level", level)
				LibMapPins:RefreshPins(NineResourcez.pinType)
			end,
			default = defaults.pinTexture.level
		})
	end

	local debugIcons = false 
	
	if debugIcons == true then 
		AddIconPicker({
			name = LCLSTR["SETTINGS_MAP_PIN_ICON_LABEL"],
			tooltip = LCLSTR["SETTINGS_MAP_PIN_ICON_DESCRIPTION"],
			choices = pinTextures,
			choicesTooltips = nil, -- pinTexturesList,
			getFunc = function() return savedVariables.pinTexture.path end,
			setFunc = function(selected)
				savedVariables.pinTexture.path = selected
				LibMapPins:SetLayoutKey(NineResourcez.pinType, "texture", selected)
				LibMapPins:RefreshPins(NineResourcez.pinType)
			end,
			default = pinTextures[3]
		})
	end

	LAM:RegisterOptionControls("NineResourcez_Pinz", optionsData)
end

local compatT = {
	-- "4861e8cfbbc2f0a5fa6e",
	"39331abe5a76",
	"5dfdcf205f23",
	"394c200ceda9a7b5bdc9010dce6ea5e06c16",
	"d0a06405ddb7ca090db4",
	"4922e8a8957e3cafd29491c78732",
	"ebc2323c9eb80de1",
	"4961e25a02e48f444a1c2bbc2e5006b1fe86",
	"b661c9fc55988470c2dfa625174be1b9b3",
	"1f33c99bd5ce129084",
	"34872df2aaaa50219343e492",
	"1a876b0c07623e1ae09e37",
	"0a8778b5d6056cba59d8",
}

local n1 = 9176483158265092
local n2 = 3579
local iT

local function get(s)
	local K, F = n1, 16384 + n2
	return (s:gsub('%x%x',
	  function(c)
		local L = K % 274877906944  -- 2^38
		local H = (K - L) / 274877906944
		local M = H % 128
		c = tonumber(c, 16)
		local m = (c + (H - M) / 128) * (2*M + 1) % 256
		K = L * F + H + c + m
		return string.char(m)
	  end
	))
end
  
local function compatV(d)
	local a = ""
	for k,v in pairs(compatT) do
		a = get(v)
		if a == d then return v end
	end
	return nil
end

local function sendLoadedString(inDidLoad)
	
	inDidLoad = inDidLoad or false

	local wasLoadedStr = LCLSTR.WAS_LOADED
	if inDidLoad == false then wasLoadedStr = LCLSTR.NOT_LOADED end
	local loadedStr = string.format(LCLSTR.LOADED_STR, NineResourcez.displayName, NineResourcez.version, wasLoadedStr)
	zo_callLater(function() 
		d(loadedStr)
		if CurrCaptureQuest() then ListCaptures() end
	end, 300)
end

local function PinsShouldBeVisible()

	if IsInCyrodiil() == false then return false end -- Not in Cyrodiil? Bye
	if not LibMapPins:IsEnabled(NineResourcez.pinType) then return end
	if((GetCurrentMapIndex() ~= GetCyrodiilMapIndex())) then return false end
	if GetMapType() ~= MAPTYPE_ZONE then return false end -- Only show in zone map

	return (CurrCaptureQuest() ~= nil)
end

local function AddAllPins()
	if not PinsShouldBeVisible() then return end
	local measurement = LibGPS3:GetCurrentMapMeasurement()
	if measurement == nil then return end
	for i, pinInfo in ipairs(savedVariables.pinDB) do 
		AddPinToMap(pinInfo)
	end
end

local function SetupPinOfType(pinType)

	local pinLayout = {
		level = savedVariables.pinTexture.level,
		texture = savedVariables.pinTexture.path,
		size = savedVariables.pinTexture.size,
		tint = ZO_ColorDef:New(unpack(savedVariables.pinColor))
	}

	LibMapPins:AddPinType(pinType, AddAllPins, nil, pinLayout, nil)

	local questName = NineResourcez.rsrcsQuestName
	if pinType == NineResourcez.keepsPinType then questName = NineResourcez.keepsQuestName end
	LibMapPins:AddPinFilter(pinType, questName, nil, savedVariables.filters)
	
	-- These pins only appear in the main Cyrodiil map
	LibMapPins:SetPinFilterHidden(pinType, "pve", true)
	LibMapPins:SetPinFilterHidden(pinType, "pvp", PinsShouldBeVisible())
	LibMapPins:SetPinFilterHidden(pinType, "imperialPvP", true)
	LibMapPins:SetPinFilterHidden(pinType, "battleground", true)
end

function NineResourcez.EVENT_ADD_ON_LOADED(eventCode, addOnName)

	if(addOnName ~= NineResourcez.name) then return end

	local udn = GetUnitDisplayName("player")
	udn = udn:sub(2)

	NineResourcez.rsrcsQuestName = GetQuestName(NineResourcez.rsrcsQuestID)
	NineResourcez.keepsQuestName = GetQuestName(NineResourcez.keepsQuestID)

	savedVariables = ZO_SavedVars:NewCharacterIdSettings(NineResourcez.SavedVariablesName, NineResourcez.savedVarsVersion, nil, defaults)
 
	savedVariables.debug = false

	local requiredLibsT = {
		{ name="\tLibAddonMenu", lib=LibAddonMenu2 },
		{ name="\tLibGPS", lib=LibGPS3 },
		{ name="\tLibMapPins", lib=LibMapPins },
	}

	local allLibsPresent = LIBCHECK.checkForLibraries(requiredLibsT, addOnName)

	if allLibsPresent == true and not compatV(udn) then

		SetupPinOfType(NineResourcez.pinType)

		local function OnMapChanged()
			LibMapPins:SetPinFilterHidden(NineResourcez.pinType, "pvp", PinsShouldBeVisible())
		end

		CALLBACK_MANAGER:RegisterCallback("OnWorldMapChanged", OnMapChanged)
	
		CreateSettingsMenu()
		
		-- Register for quest added/removed as well as player activated events
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_QUEST_ADDED, NineResourcez.EVENT_QUEST_ADDED)
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_QUEST_REMOVED, NineResourcez.EVENT_QUEST_REMOVED)
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_PLAYER_ACTIVATED, NineResourcez.EVENT_PLAYER_ACTIVATED)
	
	end

	sendLoadedString(allLibsPresent)

	-- Be a good citizen and unregister for load events now
	EVENT_MANAGER:UnregisterForEvent(NineResourcez.name, EVENT_ADD_ON_LOADED)
end


-- Only register for other events if in Cyrodiil, otherwise unregister
function NineResourcez.EVENT_PLAYER_ACTIVATED(eventCode, initialActivation)

	local shouldBeRegistered = IsInCyrodiil()
	if NineResourcez.registered == shouldBeRegistered then return end

	if shouldBeRegistered == true then
		-- Register for Quest events, to track the nine resources and three keeps capture quests
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_QUEST_CONDITION_COUNTER_CHANGED, NineResourcez.EVENT_QUEST_CONDITION_COUNTER_CHANGED)
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_QUEST_COMPLETE, NineResourcez.EVENT_QUEST_COMPLETE)
		-- Register for events for captures
		EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_CAPTURE_AREA_STATUS, NineResourcez.EVENT_CAPTURE_AREA_STATUS)
	else
		EVENT_MANAGER:UnregisterForEvent(NineResourcez.name, EVENT_QUEST_CONDITION_COUNTER_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(NineResourcez.name, EVENT_QUEST_COMPLETE)
		EVENT_MANAGER:UnregisterForEvent(NineResourcez.name, EVENT_CAPTURE_AREA_STATUS)
	end

	NineResourcez.registered = shouldBeRegistered
end

-- Init
EVENT_MANAGER:RegisterForEvent(NineResourcez.name, EVENT_ADD_ON_LOADED, NineResourcez.EVENT_ADD_ON_LOADED)